#ifndef BASE_NUMERIC_H
#define BASE_NUMERIC_H

#include <functional>
#include <utility>

namespace base {
   template <typename II, typename T, typename OP>
   inline T accumulate(II i, II f, T v, OP op)
   {
      while (i != f) {
         v = op(std::move(v), *i++);
      }

     return v;
   }

   template <typename II, typename T>
   inline T accumulate(II i, II f, T v)
   {
      return base::accumulate(i, f, std::move(v), std::plus<T>( ));
   }


   template<typename OI, typename S, typename T>
   inline OI iota_n(OI salida, S n, T v)
   {
      while (n > 0) {
         *salida++ = v;

         ++v;
         --n;
      }

      return salida;
   }
}

#endif
