#ifndef BASE_THREAD_H
#define BASE_THREAD_H

#include "integer.h"
#include <algorithm>
#include <cstdint>
#include <thread>

namespace base {
   template<typename FI, typename F>
   inline void concurrent_divide(unsigned nucleos, FI ai, FI af, const F& func)
   {
      std::thread hilos[nucleos];

      auto cuantos = base::ceil_division(af - ai, nucleos);
      auto ini = ai, fin = af;

      for (std::size_t i = 0; i < nucleos; ++i, ini = fin) {
         fin = std::min(ini + cuantos, af);
         hilos[i] = std::thread([i, ini, fin, func] {
            func(i, ini, fin);
         });
      }

      for (std::size_t i = 0; i < nucleos; ++i) {
         hilos[i].join( );
      }
   }
}

#endif
