#ifndef BASE_TYPEINFO_H
#define BASE_TYPEINFO_H

#include <type_traits>

namespace base {
   template<typename D, typename T>
   inline D polymorphic_leaf_cast(T* p)
   {
      static_assert(std::is_pointer<D>( ), "base::polymorphic_cast");
      return (typeid(typename std::remove_pointer<D>::type) == typeid(*p) ? reinterpret_cast<D>(p) : nullptr);
   }

   template<typename D, typename T>
   inline D polymorphic_cast(T* p)
   {
      static_assert(std::is_pointer<D>( ), "base::polymorphic_cast");
      return dynamic_cast<D>(p);
   }
}

#endif
